#!/usr/bin/env ruby
# this script builds symbols.js (required for the symbolinfo.js test)
# from the internal symbol table in libnanomsg.
#
# Regenerate the symbols each time a new major release of libnanomsg
# is incorporated, with:
#
# ./mksymbols >symbols.js
#
src = '../deps/nanomsg/src/core/symbol.c'
opts = []

s = File.open(src) {|f| f.read }

if m = s.match(/static\s+const\s+struct\s+nn_symbol_properties\s+
                sym_value_names\s+\[\]\s+=\s+{\s+
                (.*?)\s+};/mx)

    m[1].scan(/{([^}]+)}/s) do |n|
        a = n.first.split(/[ ,\n]+/)

        if a.length == 5
            opts.push(<<-FOO)
                'value': nn.#{a[0]},
                'name':  #{a[1].strip},
                'ns':    nn.#{a[2]},
                'type':  nn.#{a[3].strip},
                'unit':  nn.#{a[4]}
            FOO
        end
    end
end

o = opts.map {|t| "{\n" + t + "\n}"}.join(",\n")

puts <<FOO
// autogenerated from #{src} - manual edits inadvisable!
var nano = require('../');
var nn = nano._bindings;

exports.symbols = [
#{o}
];
FOO

